' Ereigniszaehler 0 - 999999

' Zaehleingang PinB.0
' Abfragetaster an PinB.2
' Buzzer an PortB.4
' rote LED an PortB.3
' gruene LED an PortB.1
' Ergebnis wird ziffernweise als eine Reihe von Blinksignalen und Piepstoenen ausgegeben
' Ziffer 0: rote LED / langer tiefer Ton
' Ziffern 1-9:  gruene LED /kurze hoehere Toene

' Compiler: BASCOM 2.0.7.5 Demo


$regfile = "Attiny13.dat"
$crystal = 1200000
$hwstack = 32
$swstack = 4
$framesize = 4

DDRB =  &B00011010
PORTB = &B00000101
DIDR0 = &B00011010
GIMSK.PCIE = 1
PCMSK.PCINT0 = 1
PCMSK.PCINT2 = 1
SREG.7 = 1

On PCINT0 Onpcint


Buzzer Alias PortB.4
Zaehleing Alias PinB.0
Abfrage Alias PinB.2
Rot Alias PortB.3
Gruen Alias PortB.1

Const Dit = 60                                              ' Laenge eines Punkts, daraus ergibt sich die Morsegeschwindigkeit
Const Dah = Dit * 3                                         ' Laenge eines Strichs
Const Dit_pause = Dit * 3 / 4
Const Dah_pause = Dit_pause * 5
Const Wort_pause = Dit_pause * 8                            ' Lnge der Pause zwischen Wrtern
Const Tonhoehe = 160

Dim I As Byte
Dim M As Byte
Dim N As Long
Dim K As Byte
Dim MS As Byte

Dim Event As Long
Dim Carry As Long
Dim Divisor As Long



Do

   If Abfrage = 0 Then
      Gosub Ausgabe
      Powerdown
   End If

Loop



' Ausgabe des Zaehlerstandes

Ausgabe:

   Carry = Event
   Divisor = 10000

   For K = 1 to 5
      N = Carry / Divisor
      Gosub Morse
      Carry = Carry Mod Divisor
      Divisor = Divisor / 10
   Next

Return



' Morsezeichenerzeugung:

Morse:

    MS = Lookup(N , Tdata)

     For I = 1 To 8
       If MS = 1 Then                                        ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Sign_end
       End If
       If MS.0 = 1 Then                                      ' ist Bit.0 = 1   -> dah
           Sound Buzzer , Dah , Tonhoehe
         Else
           Sound Buzzer , Dit , Tonhoehe                    ' ist das Bit 0 -> dit
       End If
       Waitms Dit_pause                                     ' Pause innerhalb des Morsezeichens
       Shift MS , Right , 1                                  ' Bits um eine Stelle nach rechts shiften
     Next I
     Sign_end:
     Waitms Dah_pause                                       ' Pause zwischen Morsezeichen
   Return

End


'----------------------------------------------------------

Onpcint:

If PinB.0 = 0 Then
   Waitms 10
   If PinB.0 = 0 Then
      Incr Event
   End If
End If
Return

'----------------------------------------------------------


' Codierung der Morsezeichen. Bei einem Prozessor mit viel SRAM wrde man alle Zeichen
' in ein Array einlesen (bersetzungstabelle), den eigentlichen Bakentext in einen String packen
' und diesen String zeichenenweise abarbeiten.
'
' Da der Attiny13 nur ca. 64 Byte SRAM hat, ist nur Platz fr etwa 50 Bytes. Daher ist der Weg hier
' anders: Die bersetzungstabelle ist mit Konstanten realisiert. Nur die wirklich bentigten
' Zeichen werden (beim Kompilieren des Programmes) umgewandelt.


' Const #0 = &B00111111
Const #0 = &B00000011
Const #1 = &B00111110
Const #2 = &B00111100
Const #3 = &B00111000
Const #4 = &B00110000
Const #5 = &B00100000
Const #6 = &B00100001
Const #7 = &B00100011
Const #8 = &B00100111
Const #9 = &B00101111

'Const Leerz = 0
'Const Ende = 255



Tdata:
Data #0 , #1 , #2 , #3 , #4 , #5 , #6 , #7 , #8 , #9
